-- Fischer's mutual exclusion protocol

var 
	x,      	-- P1's clock
	y      		-- P2's clock
	: analog;
	k: discrete;  	-- whose turn it is (has values 0,1,2)
	a,		-- max delay time to register intent
	b		-- min time to delay before rechecking
	: parameter
	;
 -- -------------------------------------------------------------- *)

automaton p1
synclabs : ;

initially loc_1 & True;

loc loc_1: while True wait {dx in [4/5,1]}
	when k=0 do {x' =0} goto loc_2;
	
loc loc_2: while x<=a wait {dx in [4/5,1]}
	when True do {k' =1,x' =0} goto loc_3;

loc loc_3: while True wait {dx in [4/5,1]}
	when x>=b & k=1 goto cs;
	-- two failed attempts
	when x>=b & k=0 goto loc_1;
	when x>=b & k=2 goto loc_1;

loc cs: while True wait {dx in [4/5,1]}
	when True do {k' = 0} goto loc_1;
end


automaton p2
synclabs : ;

initially loc_1 & True;

loc loc_1: while True wait {dy in [1,11/10]}
	when k=0 do {y' =0} goto loc_2;
	
loc loc_2: while y<=a wait {dy in [1,11/10]}
	when True do {k' =2, y' =0} goto loc_3;

loc loc_3: while True wait {dy in [1,11/10]}
	when y>=b & k=2 goto cs;
	-- two failed attempts
	when y>=b & k=0 goto loc_1;
	when y>=b & k=1 goto loc_1;

loc cs: while True wait {dy in [1,11/10]}
	when True do {k' = 0} goto loc_1;
end

--

var 
   init_reg, final_reg, reached : region;

init_reg:= loc[p1] = loc_1 & loc[p2] = loc_1 & k=0;

final_reg:= loc[p1] = cs & loc[p2] = cs;

reached:= reach backward from final_reg endreach;

prints "Condition for faulty system";

print omit all locations hide non_parameters in reached & init_reg endhide;



