#ifndef __LOCATION_H
#define __LOCATION_H


#include "include.h"

/* added for testing why get malloc warnings */
/* solves the problem */
/* #include <stdlib.h> */




#ifdef __cplusplus
extern "C" {
#endif

struct info_assign {
  /* HWT. vect1 is single vector for a single ass. constraint */
  /* in assignment matrix */
  /* vect2 is ignored */
  int var_id, vect1, vect2;
  struct info_assign * next;
}; 

struct info_transition {
  char * destination, * synlabel;
  int matrix_guard_id, transition_number;
  struct info_assign * assign;
  struct info_transition * next;
  int was_asap;
  /* added 10/19/95 */
  int *ass_vars;
};

struct info_location {
  char * location_name;
  int matrix_inv_id, location_number;
  int slope_matrix_id;
  struct slope_entry * slopes;
  int slop_start_vect, slop_end_vect;
  struct info_transition * transitions;
  struct info_location * next;
};

extern struct info_location * locations;

void produce_slope_vectors(void);
void new_location(char * loc);
void get_inv_id(void);
void get_guard_id(void);
void get_slopvec(void);
void new_transition(void);
struct info_assign * ga(int num, struct _p_vector * vptr);
void get_assignments(int num); 
void get_destination(char * dest);
void get_synlabel(char * synlab);
void psv(int step, int max, struct _p_vector * v);
void produce_slope_vectors(void);
void new_automaton(void);

/* added this declaration to the header -- HWT 2/26/95 */
int loc_index(char * name);

extern int *transitions_to(int loc_n);

/* multiple-automata extension */
struct automata_list { 
  struct _p_vector * vectors;
  struct _p_matrix * matrices;
  struct info_location * locations;
  char * init_loc_name;
  int  init_m_id;           /* matrix ID of initial matrix. */
  int nr_event_labels;
  char * automaton_name;
  struct var_name *event_labels;
  struct automata_list * next;
};

extern struct automata_list * automata; 

/* ptr to list of integers, for whether each var has been reassigned */


void set_assgt_vars_empty();

#ifdef __cplusplus
}
#endif

#endif
